  10 GO TO 9000
#================
#Fill coord arrays
#================
 100 READ A
 110 FOR N=1 TO A
 120  READ X(N): READ Y(N)
#ZX81 to Spectrum scaling
 130  LET Y(N)=INT (Y(N)*.916)
 140 NEXT N
#Loop thru C rotations
 150 FOR N=1 TO C
 160  PLOT X(1),Y(1)
#Loop thru G sides
 170  FOR M=1 TO G
 180   LET NJ=M+1 : IF NJ=G+1 THEN LET NJ=1
 190   INK VAL C$(M)
#Convert absolute coords to relative coords
 200   DRAW X(NJ)-PEEK 23677,Y(NJ)-PEEK 23678
#Downsize coords for next loop
 210   LET Z(M)=RU*X(M)+SU*X(NJ)
 220   LET T(M)=RU*Y(M)+SU*Y(NJ)
 230  NEXT M
#Fill arrays with downsized coords
 240  FOR P=1 TO G
 250   LET X(P)=Z(P): LET Y(P)=T(P)
 260  NEXT P
 270 NEXT N
 280 BEEP .1,1 : PAUSE 4E4: RUN
#================
#INPUT ROUTINE
#================
 500 DIM R$(32)
 510 LET MAX=VAL I$(1 TO 3)
 520 PRINT AT 21,0;R$;AT 21,0;I$(4 TO );"?"
 530 INPUT R
 540 IF R<0 OR R>MAX THEN GO TO 530
 550 PRINT AT 21,0;R$
 560 RETURN
#================
#LINES
#================
 600 CLS : INK 2: PRINT ,,"Computer Art",,,, : INK 4 : PRINT "\
 This routine draws a constantly\
moving-twisting line. You choose\
the number of lines to draw. The\
display is  restarted after each\
line count is finished.",,,"\
 Pressing any key returns to the\
main menu."
 610 INPUT INK 4; "Line Count? ";R
 620 INPUT INK 4; "Mono or Rainbow mix? (M/R) "; M$
 630 LET W=1 : LET L=1
 640 IF M$="r" THEN INPUT INK 4; "Bandwidth? "; W
 650 CLS : RANDOMIZE : LET Hue=RND*7+1 : INK Hue
 660 LET A=INT (RND*255): LET B=INT (RND*175)
 670 LET X=INT (RND*255): LET Y=INT (RND*175)
 680 LET A1=2: LET B1=2: LET X1=4: LET Y1=4
 690 FOR N=1 TO R
 700  IF INKEY$<>"" THEN RUN
 710  LET L=L+1
 720  IF L=W AND M$="r" THEN LET Hue=RND*7+1: LET L=1: INK Hue
 730  PLOT A,B: DRAW X-A,Y-B
 740  LET A=A+A1: LET B=B+B1: LET X=X+X1: LET Y=Y+Y1
 750  IF A<=0 OR A>=255 THEN LET A1=-A1: LET A=A+A1
 760  IF X<=0 OR X>=255 THEN LET X1=-X1: LET X=X+X1
 770  IF B<=0 OR B>=175 THEN LET B1=-B1: LET B=B+B1
 780  IF Y<=0 OR Y>=175 THEN LET Y1=-Y1: LET Y=Y+Y1
 790 NEXT N
 795 GO TO 650
#================
#NODES
#================
 800 CLS : INK 2 : PRINT ,,"Nodes",,,,: INK 4 : PRINT "\
This item draws a  regular poly-\
gon with all the diagonals.  You\
choose the  number of  nodes,the\
color is randomly selected.",,,"\
                Roald A. Schrack"
 810 INPUT INK 4; "Number of nodes? ";R
 820 CLS : RANDOMIZE : INK RND*7+1
 830 DIM X(60): DIM Y(60)
 840 FOR N=1 TO R
 850  LET Z=2*PI*N/R
 860  LET X(N)=INT (24*(4*SIN (Z)+15)*.91)
 870  LET Y(N)=INT (24*(4*COS (Z)+8)*.91)
 880 NEXT N
 900 FOR N=1 TO R-1
# 910  LET IP=N+1
 920  LET A=X(N)-199 : LET B=Y(N)-87
#INK VAL C$(N)
 930  FOR M=N+1 TO R
 940   PLOT A,B
 950   DRAW X(M)-199-A,Y(M)-87-B
 960  NEXT M
 970 NEXT N
 980 BEEP .1,1 : PAUSE 4E4: RUN
#================
# Polygon definitions
#================
1003 DATA "Triangle  ",03,000,000,128,191,255,000
1004 DATA "Quadrangle",04,000,000,000,191,255,191,255,000
1005 DATA "Pentagon  ",05,128,191,228,119,191,000,066,000,028,119
1006 DATA "Hexagon   ",06,128,000,211,048,211,144,128,190,045,144,045,048
1007 DATA "Heptagon  ",07,128,187,203,151,222,070,171,005,086,005,034,070,053,151
1008 DATA "Octagon   ",08,128,000,196,028,224,096,196,164,128,190,060,164,032,096,060,028
1009 DATA "Nonagon   ",09,128,189,190,167,223,110,211,045,162,003,095,003,045,045,033,110,065,167
1010 DATA "Decagon   ",10,128,190,185,174,219,126,219,066,184,018,128,000,071,018,037,066,037,126,072,174
1011 DATA "Undecagon ",11,128,190,180,175,215,134,223,080,201,031,156,002,101,002,055,031,033,080,041,134,075,175
1012 DATA "Dodecagon ",12,128,190,177,180,211,145,224,097,211,049,176,014,128,001,079,014,045,049,032,097,045,145,080,180
#================
#INITIALIZE
#================
9000 PAPER 0: BORDER 0 : BRIGHT 1: INK 4: CLS
9010 PRINT "\
  Select Polygon",,,"\
   1. Lines",,"\
   2. Nodes",,"\
   3. Triangle",,"\
   4. Quadrilateral","\
   5. Pentagon",,"\
   6. Hexagon",,"\
   7. Heptagon",,"\
   8. Octagon",,"\
   9. Nonagon",,"\
  10. Decagon",,"\
  11. Undecagon",,"\
  12. Dodecagon",,"\
  13. Quit";
9020 INPUT INK 4;"Item Number? ";R: IF R>13 THEN GO TO 9020
9030 LET G=R
9040 IF G=13 THEN CLS : STOP
9050 IF G=1 OR G=2 THEN GO TO 600+200*(G=2)
9060 DIM X(G): DIM Y(G): DIM Z(G): DIM T(G)
9070 RESTORE 1000+G: READ A$
9075 CLS : PRINT ,,,,;"Polygon: "; : INK 2 : PRINT A$,,,; : INK 4
9080 INPUT INK 4;"Rotational Spacing? ";R
9085 PRINT "Spacing: ";R
9090 LET SU=R/100: LET RU=1-SU
9100 INPUT INK 4;"Polygon Count? ";C
9105 PRINT ,,"  Count: ";C,,,,
9110 PRINT "\
================================\
 0-Black 1-Blue 2-Red  3-Magenta\
 4-Green 5-Cyan 6-Yell 7-White  \
================================",,"\
Enter "; : INK 2 : PRINT G; : INK 4 : PRINT " digit color mix or","\
R for ""Rainbow"" mix or","\
"""" for random mono color."
9120 INPUT INK 4;"Color Scheme? ";C$
9130 IF C$="" THEN GO SUB 9300
9140 IF C$="r" THEN GO SUB 9350
9150 IF LEN C$<>G THEN GO TO 9110
9160 CLS : GO TO 100
#================
#Random mono
#================
9300 RANDOMIZE
9305 LET A$=STR$ (INT (RND*7)+1)
9310 FOR N=1 TO G
9315  LET C$=C$+A$
9320 NEXT N
9325 RETURN
#================
#Rainbow mix
#================
9350 LET C$=""
9355 RANDOMIZE
9360 FOR N=1 TO G
9365  LET C$=C$+STR$ (INT (RND*7)+1)
9370 NEXT N
9375 RETURN

9990 SAVE "POLYGONS-S" LINE 1